module LolApi
	class Timeline
		attr_reader :raw_timeline

		def initialize(raw_timeline)
			@raw_timeline = raw_timeline
		end

		def interval
			@raw_timeline['frameInterval']
		end

		def frames
			if frames = @raw_timeline['frames']
				frames.map { |x| Frame.new(x) }
			end
		end
	end

	class Frame
		attr_reader :raw_frame

		def initialize(raw_frame)
			@raw_frame = raw_frame
		end

		def events 
			if events = @raw_frame['events']
				events.map { |x| Event.new(x) }
			else
				[]
			end
		end

		def participant_frames 
			if frames = @raw_frame['participantFrames']
				frames.map{|x| ParticipantFrame.new(x[1])}
			else
				[]
			end
		end

		def timestamp 
			@raw_frame['timestamp']
		end
	end

	class Event
		attr_reader :raw_event

		def initialize(raw_event)
			@raw_event = raw_event
		end

		def assisting_participant_ids
			raw_event['assistingParticipantId']
		end

		def building_type
			raw_event['buildingType']
		end

		def creator_id
			raw_event['creatorId']
		end

		def event_type
			raw_event['eventType']
		end

		def item_after
			raw_event['itemAfter']
		end

		def item_before
			raw_event['itemBefore']
		end

		def item_id
			raw_event['itemId']
		end

		def killer_id
			raw_event['killerId']
		end

		def lane_type
			raw_event['laneType']
		end

		def level_up_type
			raw_event['levelUpType']
		end

		def monster_type
			raw_event['monsterType']
		end

		def participant_id
			raw_event['participantId']
		end

		def position
			raw_event['position']
		end

		def skill_slot
			raw_event['skillSlot']
		end

		def team_id
			raw_event['teamId']
		end

		def timestamp
			raw_event['timestamp']
		end

		def tower_type
			raw_event['towerType']
		end

		def victim_id
			raw_event['victimId']
		end

		def ward_type
			raw_event['wardType']
		end
	end

	class ParticipantFrame
		attr_reader :raw_frame

		def initialize(raw_frame)
			@raw_frame = raw_frame
		end

		def current_gold
			@raw_frame['currentGold']
		end

		def jungle_minions_killed
			@raw_frame['jungleMinionsKilled']
		end

		def level
			@raw_frame['level']
		end

		def minions_killed
			@raw_frame['minionsKilled']
		end

		def participant_id
			@raw_frame['participantId']
		end

		def position
			Position.new(@raw_frame['position'])
		end

		def total_gold
			@raw_frame['totalGold']
		end

		def xp
			@raw_frame['xp']
		end
	end

	class Position

		def initialize(raw_pos)
			@x = raw_pos['x']
			@y = raw_pos['y']
		end
	end

end