require 'lol_api/types/dtos/team'
require 'lol_api/types/dtos/timeline'
require 'lol_api/types/history_match'

module LolApi
	class Match < HistoryMatch
		def match_type
			raw_match['matchType']
		end

		def match_mode
			raw_match['matchMode']
		end

		def teams
			if teams = raw_match['teams']
				teams.map { |e| Team.new(e) }
			end
		end

		def timeline
			Timeline.new(raw_match['timeline'])
		end

		def blue_team 
			[ teams[0], participants.select { |x| x.team_id == 100 } ]
		end

		def purple_team
			[ teams[1], participants.select { |x| x.team_id == 200 } ]
		end

		def ward_placements
			timeline.frames.map do |f|
				f.events.select do |e|
					e.event_type == "WARD_PLACED"
				end
			end.flatten
		end

	end
end

